package com.hotwj.platform.resourceManagement.temporary.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.resourceManagement.temporary.domain.HotTemporary;
import com.hotwj.platform.resourceManagement.temporary.domain.bo.HotTemporaryBo;
import com.hotwj.platform.resourceManagement.temporary.domain.vo.HotTemporaryVo;
import com.hotwj.platform.resourceManagement.temporary.mapper.HotTemporaryMapper;
import com.hotwj.platform.resourceManagement.temporary.service.IHotTemporaryService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 前端缓存信息Service业务层处理
 *
 * @author shihongwei
 * @date 2026-03-02
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotTemporaryServiceImpl implements IHotTemporaryService {

    private final HotTemporaryMapper baseMapper;

    /**
     * 查询前端缓存信息
     *
     * @param id 主键
     * @return 前端缓存信息
     */
    @Override
    public HotTemporaryVo queryById(String id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询前端缓存信息列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 前端缓存信息分页列表
     */
    @Override
    public TableDataInfo<HotTemporaryVo> queryPageList(HotTemporaryBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotTemporary> lqw = buildQueryWrapper(bo);
        Page<HotTemporaryVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的前端缓存信息列表
     *
     * @param bo 查询条件
     * @return 前端缓存信息列表
     */
    @Override
    public List<HotTemporaryVo> queryList(HotTemporaryBo bo) {
        LambdaQueryWrapper<HotTemporary> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotTemporary> buildQueryWrapper(HotTemporaryBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotTemporary> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotTemporary::getId);
        lqw.eq(bo.getCompanyId() != null, HotTemporary::getCompanyId, bo.getCompanyId());
        lqw.eq(StringUtils.isNotBlank(bo.getTemporaryType()), HotTemporary::getTemporaryType, bo.getTemporaryType());
        lqw.eq(StringUtils.isNotBlank(bo.getJsonStr()), HotTemporary::getJsonStr, bo.getJsonStr());
        lqw.eq(bo.getIsDeleted() != null, HotTemporary::getIsDeleted, bo.getIsDeleted());
        lqw.like(StringUtils.isNotBlank(bo.getCreateByName()), HotTemporary::getCreateByName, bo.getCreateByName());
        lqw.like(StringUtils.isNotBlank(bo.getUpdateByName()), HotTemporary::getUpdateByName, bo.getUpdateByName());
        return lqw;
    }

    /**
     * 新增前端缓存信息
     *
     * @param bo 前端缓存信息
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotTemporaryBo bo) {
        HotTemporary add = MapstructUtils.convert(bo, HotTemporary.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改前端缓存信息
     *
     * @param bo 前端缓存信息
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotTemporaryBo bo) {
        HotTemporary update = MapstructUtils.convert(bo, HotTemporary.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotTemporary entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除前端缓存信息信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
